#!/bin/sh
#
#       /etc/rc.d/init.d/
#
#

start() {
#       echo -n "Starting : moss"

	echo installing missouri modules
	{
		cd /opt/missouri/modules
		insmod ./mosscfg.ko
		insmod ./mossdpm.ko
		insmod ./mosscdr.ko
		insmod ./mossbmf.ko
		insmod ./mossdq.ko
		insmod ./mossrx.ko
	}

	sleep 2

	echo making missouri device nodes
	{
		mknod -m a=rw /dev/moCFG c 254 0
		mknod -m a=rw /dev/moMGT c 254 1
		mknod -m a=rw /dev/moDCM c 254 2
		mknod -m a=rw /dev/moVCT c 254 3
		mknod -m a=rw /dev/moVCA c 254 4

		mknod -m a=rw /dev/moDPM1 c 253 1
		mknod -m a=rw /dev/moDPM2 c 253 2
		mknod -m a=rw /dev/moDPM3 c 253 3
		mknod -m a=rw /dev/moDPM4 c 253 4
		mknod -m a=rw /dev/moDPM5 c 253 5
		mknod -m a=rw /dev/moDPM6 c 253 6

		mknod -m a=rw /dev/moCH1 c 252 1
		mknod -m a=rw /dev/moCH2 c 252 2
		mknod -m a=rw /dev/moCH3 c 252 3
		mknod -m a=rw /dev/moCH4 c 252 4
		mknod -m a=rw /dev/moCH5 c 252 5
		mknod -m a=rw /dev/moCH6 c 252 6

		mknod -m a=rw /dev/moCM1 c 251 1
		mknod -m a=rw /dev/moCM2 c 251 2

		mknod -m a=rw /dev/moDQS c 250 1
		mknod -m a=rw /dev/moRX1 c 249 1
		mknod -m a=rw /dev/moRX2 c 249 2
	}

	sleep 1

	echo initializing image cache hardware
	{
		cd /opt/missouri/bin

		echo Hardware Resets
		./mosseth --mgt
		./mosseth --dcm
		sleep 1

		echo Auto-Timer Configuration
		./mosseth  --auto-rx1
		./mosseth  --auto-rx2

		echo DIMM Configuration
		echo "CTL raw=0x400" > /dev/moCFG
		./mosseth --auto-dimm
		echo "CTL raw=0x000" > /dev/moCFG
		./mosseth --auto-dimm 
		sleep 1

		./mosseth  --daemon --host /dev/moDPM6
		sleep 1
	}

	sleep 1

	{
		cd /opt/missouri/bin
		sleep 1
		./mossice  --video /dev/moCH1 --key /dev/moCH2
		sleep 1
		./mossice  --video /dev/moCH3 --key /dev/moCH4
		sleep 1
		./mossice  --video /dev/moCH5 --key /dev/moCH6
		sleep 1
	}

	sleep 1

	echo starting image cache engine
	{
		cd /opt/missouri/bin
		./mossice  --daemon --host /dev/moDPM1 --video /dev/moCH1 --key /dev/moCH2
		sleep 1
		./mossice  --daemon --host /dev/moDPM2 --video /dev/moCH3 --key /dev/moCH4
		sleep 1
		./mossice  --daemon --host /dev/moDPM3 --video /dev/moCH5 --key /dev/moCH6
		sleep 1
		./mossedr  --daemon --host /dev/moDPM5
		sleep 1
	}

	sleep 1

	echo starting httpd
	{
		cd /var/www
		httpd
	}

	sleep 1

	echo starting image share
	{
		cd /opt/missouri/bin

		export USER=root
		export HOME=/root
		export LOGNAME=root
		export TERM=linux
		export SHELL=/bin/sh

		nice -n 2 ./mosshare --daemon --host /dev/moDPM4 --rowsperstrip 1
	}

	echo "				complete"
        return
}

stop() {
        echo -n "Shutting down : moss"
        return
}

case "$1" in
    start)
        start
        ;;
    stop)
        stop
        ;;
    *)
        echo "Usage: $0 {start|stop}"
        exit 1
        ;;
esac
exit $?

